// Unit Collisions
(**************************************************

- Enthlt: Kollisionsabfragen

**************************************************)

unit F2D_Collisions;

interface

uses
  windows, math;

//Prft of zwei Rects kollidieren
function RectRectIntersect(A, B: TRect): boolean; overload;
//C wird ein Rect bergeben, welches dann die Werte des Kollisionsrechtecks erhlt
function RectRectIntersect(A, B: TRect; var C: TRect): boolean; overload;

implementation

function RectRectIntersect(A, B: TRect): boolean;
begin
  Result := (A.Left <= B.Right) and (A.Right >= B.Left) and (A.Top <= B.Bottom) and (A.Bottom >= B.Top);
end;

function RectRectIntersect(A, B: TRect; var C: TRect): boolean;
begin
  result := RectRectIntersect(A, B);
  if Result = true then
  with C do
  begin
    Left   := max(min(A.Right, B.Left), min(A.Left, B.Right));
    Right  := min(max(A.Right, B.Left), max(A.Left, B.Right));
    Top    := max(min(A.Bottom, B.Top), min(A.Top, B.Bottom));
    Bottom := min(max(A.Bottom, B.Top), max(A.Top, B.Bottom));
  end;
end;

end.
